<?php

/**
 * Fanfics System Mod by Kaero Webs
 *
 * Version 1.2
 **/

if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once(dirname(__FILE__) . '/SSI.php');
elseif (!defined('SMF'))
	die('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

db_extend('packages');

global $smcFunc;

add_integration_function('integrate_pre_include', '$sourcedir/FanficsHooks.php', true);
add_integration_function('integrate_actions','hook_fanfics_actions', true);
add_integration_function('integrate_load_permissions','hook_fanfics_load_permissions', true);
add_integration_function('integrate_menu_buttons','hook_fanfics_menu_buttons', true);
add_integration_function('integrate_admin_areas','hook_fanfics_admin_areas', true);
add_integration_function('integrate_delete_member','hook_fanfics_delete_member', true);

if (SMF == 'SSI')
	echo 'Hooks successfully added!<br />';

/*
 * CREATE TABLE
 */
$fanfics_tables = array(
	'columns' => array(
		array(
			'name' => 'id_category',
			'type' => 'int',
			'size' => 11,
			'auto' => true,
			'unsigned' => true,
		),
		array(
			'name' => 'name',
			'type' => 'varchar',
			'size' => 60,
		),
		array(
			'name' => 'childs',
			'type' => 'int',
			'size' => 11,
			'default' => 0,
			'unsigned' => true,
		),
		array(
			'name' => 'stories',
			'type' => 'int',
			'size' => 11,
			'default' => 0,
			'unsigned' => true,
		),
		array(
			'name' => 'id_parent',
			'type' => 'int',
			'size' => 11,
			'unsigned' => true,
		)
	),
	'indexes' => array(
		array(
		'type' => 'primary',
		'columns' => array('id_category')
		)
	)
);

$smcFunc['db_create_table']('{db_prefix}fanfics_categories', $fanfics_tables['columns'], $fanfics_tables['indexes'], array(), 'ignore');

$fanfics_tables = array(
	'columns' => array(
		array(
			'name' => 'id_chapter',
			'type' => 'int',
			'size' => 11,
			'auto' => true,
			'unsigned' => true,
		),
		array(
			'name' => 'title',
			'type' => 'varchar',
			'size' => 255,
		),
		array(
			'name' => 'storytext',
			'type' => 'longtext',
		),
		array(
			'name' => 'inorder',
			'type' => 'int',
			'size' => 11,
			'unsigned' => true,
		),
		array(
			'name' => 'created',
			'type' => 'int',
			'size' => 10,
			'unsigned' => true,
		),
		array(
			'name' => 'id_story',
			'type' => 'int',
			'size' => 11,
			'unsigned' => true,
		)
	),
	'indexes' => array(
		array(
		'type' => 'primary',
		'columns' => array('id_chapter')
		)
	)
);

$smcFunc['db_create_table']('{db_prefix}fanfics_chapters', $fanfics_tables['columns'], $fanfics_tables['indexes'], array(), 'ignore');

$fanfics_tables = array(
	'columns' => array(
		array(
			'name' => 'id_like',
			'type' => 'int',
			'size' => 11,
			'auto' => true,
			'unsigned' => true,
		),
		array(
			'name' => 'id_member',
			'type' => 'mediumint',
			'size' => 8,
			'unsigned' => true,
		),
		array(
			'name' => 'id_story',
			'type' => 'int',
			'size' => 11,
			'unsigned' => true,
		)
	),
	'indexes' => array(
		array(
		'type' => 'primary',
		'columns' => array('id_like')
		)
	)
);

$smcFunc['db_create_table']('{db_prefix}fanfics_likes', $fanfics_tables['columns'], $fanfics_tables['indexes'], array(), 'ignore');

$fanfics_tables = array(
	'columns' => array(
		array(
			'name' => 'id_rating',
			'type' => 'int',
			'size' => 11,
			'auto' => true,
			'unsigned' => true,
		),
		array(
			'name' => 'name',
			'type' => 'varchar',
			'size' => 60,
		),
		array(
			'name' => 'ageconsent',
			'type' => 'tinyint',
			'size' => 1,
			'unsigned' => true,
		),
		array(
			'name' => 'stories',
			'type' => 'int',
			'size' => 11,
			'default' => 0,
			'unsigned' => true,
		)
	),
	'indexes' => array(
		array(
		'type' => 'primary',
		'columns' => array('id_rating')
		)
	)
);

$smcFunc['db_create_table']('{db_prefix}fanfics_ratings', $fanfics_tables['columns'], $fanfics_tables['indexes'], array(), 'ignore');

$fanfics_tables = array(
	'columns' => array(
		array(
			'name' => 'variable',
			'type' => 'varchar',
			'size' => 255,
		),
		array(
			'name' => 'value',
			'type' => 'text',
		)
	),
	'indexes' => array(
		array(
		'type' => 'primary',
		'columns' => array('variable')
		)
	)
);

$smcFunc['db_create_table']('{db_prefix}fanfics_stats', $fanfics_tables['columns'], $fanfics_tables['indexes'], array(), 'ignore');

$fanfics_tables = array(
	'columns' => array(
		array(
			'name' => 'id_story',
			'type' => 'int',
			'size' => 11,
			'auto' => true,
			'unsigned' => true,
		),
		array(
			'name' => 'title',
			'type' => 'varchar',
			'size' => 255,
		),
		array(
			'name' => 'summary',
			'type' => 'text',
		),
		array(
			'name' => 'chapters',
			'type' => 'int',
			'size' => 11,
			'default' => 1,
			'unsigned' => true,
		),
		array(
			'name' => 'completed',
			'type' => 'tinyint',
			'size' => 1,
			'unsigned' => true,
		),
		array(
			'name' => 'created',
			'type' => 'int',
			'size' => 10,
			'unsigned' => true,
		),
		array(
			'name' => 'updated',
			'type' => 'int',
			'size' => 10,
			'unsigned' => true,
		),
		array(
			'name' => 'likes',
			'type' => 'mediumint',
			'size' => 8,
			'default' => 0,
			'unsigned' => true,
		),
		array(
			'name' => 'views',
			'type' => 'int',
			'size' => 11,
			'default' => 0,
			'unsigned' => true,
		),
		array(
			'name' => 'approved',
			'type' => 'tinyint',
			'size' => 1,
			'unsigned' => true,
		),
		array(
			'name' => 'checked',
			'type' => 'tinyint',
			'size' => 1,
			'default' => 1,
			'unsigned' => true,
		),
		array(
			'name' => 'id_member',
			'type' => 'mediumint',
			'size' => 8,
			'unsigned' => true,
		),
		array(
			'name' => 'id_category',
			'type' => 'int',
			'size' => 11,
			'unsigned' => true,
		),
		array(
			'name' => 'id_rating',
			'type' => 'int',
			'size' => 11,
			'unsigned' => true,
		),
		array(
			'name' => 'id_topic',
			'type' => 'mediumint',
			'size' => 8,
			'unsigned' => true,
		)
	),
	'indexes' => array(
		array(
		'type' => 'primary',
		'columns' => array('id_story')
		)
	)
);

$smcFunc['db_create_table']('{db_prefix}fanfics_stories', $fanfics_tables['columns'], $fanfics_tables['indexes'], array(), 'ignore');

/*
 * CHANGE COLUMN (UPGRADE FROM 1.1)
 */
$fanfics_tables = $smcFunc['db_table_structure']('{db_prefix}fanfics_chapters');

if ($fanfics_tables['columns']['storytext']['type'] != 'longtext')
	$smcFunc['db_change_column']('{db_prefix}fanfics_chapters', 'storytext', array('type' => 'longtext'));
	
$fanfics_tables = $smcFunc['db_table_structure']('{db_prefix}fanfics_ratings');

if ($fanfics_tables['columns']['stories']['default'] == null)
	$smcFunc['db_change_column']('{db_prefix}fanfics_ratings', 'stories', array('default' => 0, 'unsigned' => true));

/*
 * INSERT
 */
$fanfics_tables = array(
	'columns' => array('variable' => 'string', 'value' => 'string'),
	'values' => array(
		array('stories', '0'),
		array('chapters', '0'),
		array('authors', '0')
	),
	'key' => array('variable')
);

$smcFunc['db_insert']('ignore', '{db_prefix}fanfics_stats', $fanfics_tables['columns'], $fanfics_tables['values'], $fanfics_tables['key']);

$fanfics_tables = array(
	'columns' => array('id_group' => 'int', 'permission' => 'string'),
	'values' => array(
		array(-1, 'view_fanfics'),
		array(0, 'view_fanfics'),
		array(2, 'view_fanfics')
	),
	'key' => array('variable')
);

$smcFunc['db_insert']('ignore', '{db_prefix}permissions', $fanfics_tables['columns'], $fanfics_tables['values'], $fanfics_tables['key']);

$fanfics_tables = array(
	'columns' => array('variable' => 'string', 'value' => 'string'),
	'values' => array(
		array('fanfics_ageconsent', '1'),
		array('fanfics_showstats', '1'),
		array('fanfics_orderby', '3'),
		array('fanfics_perpage', '15'),
		array('fanfics_allowbbc', '1')
	),
	'key' => array('variable')
);

$smcFunc['db_insert']('ignore', '{db_prefix}settings', $fanfics_tables['columns'], $fanfics_tables['values'], $fanfics_tables['key']);

if (SMF == 'SSI')
	echo 'Tables successfully added!';

?>